<?php

/**
 *
 * $Id: NewsletterPlugin.class.php,v 1.5 2007-05-05 17:10:36 jankul Exp $
 *
 */

require_once 'classes/AdditionalEmails.class.php';
require_once 'classes/NWorker.class.php';

class NewsletterPlugin extends AbstractStudIPPortalPlugin {

	var $user = NULL;	
	var $permissions;
	var $mail_localhost;
	var $sender_email;
	var $template_path;
        var $factory;

	function NewsletterPlugin() {
		parent::AbstractStudIPPortalPlugin();
		$this->template_path = dirname(__FILE__) . '/templates';
                $this->factory = new Flexi_TemplateFactory($this->template_path);
		$nav = new PluginNavigation();
		$nav->setDisplayname(_("Newsletter"));		
		$this->setNavigation($nav);				
		$this->user = $this->getUser();							
		$this->permissions = $this->user->getPermission();
		$this->setPluginiconname("img/news2.gif");
		$this->mail_localhost = ($GLOBALS['MAIL_LOCALHOST'] == "") ? $_SERVER["SERVER_NAME"] : $GLOBALS['MAIL_LOCALHOST'];
		$this->sender_email = ($GLOBALS['MAIL_ENV_FROM'] == "" ? "info@" . $this->mail_localhost : $GLOBALS['MAIL_ENV_FROM']);
	}

	function getPluginname() {
		return "Newsletter Plugin";
	}

	function createInfoBox ($imgLogo) {
                $info1 =  array ("icon" => "info.gif", "text" => _("Sie k&ouml;nnen beliebig viele, thematisch verschiedene Newsletter anlegen."));
                $info2 =  array ("icon" => "forum_fav.gif", "text" => _("Solange es keine Abonnenten in einem Newsletter gibt, ist die Sende-Funktion deaktiviert. Sie k&ouml;nnen aber dennoch Artikel anlegen, bearbeiten und vorab an eine Testadresse Ihrer Wahl verschicken."));
                $info3 =  array ("icon" => "meinesem.gif", "text" => _("W&auml;hlen Sie beim Erstellen eines Artikels zwischen <B>Plain-Text</B>, <B>Stud.IP</B> und <B>HTML</B> Formatierungen. Beachten Sie hierbei bitte, dass E-Mails mit HTMl-Formatierung (dazu z&auml;hlt auch die Stud.IP-Formatierung) nicht &uuml;berall gerne gesehen werden!"));
                $infobox = array (array ("kategorie" => _("Information:"), "eintrag"   => array ($info1, $info2, $info3)));
                return print_infobox ($infobox, $imgLogo, YES);
        }

	function generate_xinha_env() {
		$xinha_path = $GLOBALS['ABSOLUTE_URI_STUDIP'].$this->getPluginpath()."/xinha";
		echo "<script type=\"text/javascript\">\n";
    		echo "_editor_url  = \"".$xinha_path."/\";  // (preferably absolute) URL (including trailing slash) where Xinha is installed\n";
    		echo "_editor_lang = \"en\";      // And the language we need to use in the editor.\n";
  		echo "</script>\n";
  		echo "<script type=\"text/javascript\" src=\"".$xinha_path."/XinhaCore.js\"></script>\n";
		echo "<script type=\"text/javascript\" src=\"".$xinha_path."/my_config.js\"></script>\n";

	}

	function showOverview($unauthorizedview = TRUE){
		global $PHP_SELF;
		$GLOBALS['perm']->check('autor');
		$db = new DB_Seminar();
		$modus = trim($_REQUEST['nlmodus']);
		$open = trim($_REQUEST['open']);
		$opennl = trim($_REQUEST['opennl']);
		$newsletter_id = trim($_REQUEST['newsletter_id']);
		if ($modus == "join") {
			if ($newsletter_id != "" && !NWorker::is_member($newsletter_id)) {
				$t = time();
				$token = md5(uniqid($t));
				$db->queryf("INSERT INTO newsletter_user (newsletter_id, user_id, mkdate, sec_token) VALUES ('%s','%s',%d,'%s')",$newsletter_id,$this->user->getUserId(),$t,$token);
			}
		}
		if ($modus == "unjoin") {
			if ($newsletter_id != "")
				$db->queryf("DELETE FROM newsletter_user WHERE newsletter_id='%s' AND user_id='%s'",$newsletter_id,$this->user->getUserId());
		}
		if ($modus == "show_archive") {
			echo "<A NAME=\"ankerar\" />\n";
			echo "<A HREF=\"$PHP_SELF?opennl=".$open."#ankernl\"><FONT STYLE=\"font-size:12px;\">&lt;&lt;"._("zur&uuml;ck")."</FONT></A><BR>\n";
			$db->queryf("SELECT * FROM newsletter WHERE newsletter_id='%s'",$open);
			if ($db->next_record()) {
				echo "<B STYLE=\"font-size:12px;\">".sprintf(_("Archiv des Newsletters %s"),htmlReady($db->f("titel")))."</B><BR><BR>\n";
			}
			$db->queryf("SELECT * FROM newsletter_content WHERE newsletter_id='%s' AND posted > 0 ORDER BY posted DESC",$open);
			while ($db->next_record()) {
				echo "<A HREF=\"$PHP_SELF?nlmodus=show_article&open=".$db->f("newsletter_id")."&article=".$db->f("content_id")."#ankerart\"><FONT STYLE=\"font-size:12px;\">".date("d.m.Y",$db->f("posted"))." ".htmlReady($db->f("titel"))."</FONT></A><BR>\n";
			}
			echo "<BR>\n";
		}
		if ($modus == "show_article") {
			echo "<A NAME=\"ankerart\" />\n";
			echo "<A HREF=\"$PHP_SELF?nlmodus=show_archive&open=".$open."#ankerar\"><FONT STYLE=\"font-size:12px;\">&lt;&lt;"._("zur&uuml;ck")."</FONT></A><BR>\n";
			$db->queryf("SELECT * FROM newsletter_content WHERE content_id='%s' AND posted > 0",trim($_REQUEST['article']));
			if ($db->next_record()) {
				echo "<B STYLE=\"font-size:12px;\">".htmlReady($db->f("titel"))."</B><BR><BR>\n";
				echo "<SPAN STYLE=\"font-size:12px;\">\n";
				if ($db->f("format") == "html")
					echo $db->f("content");
				else
					echo formatReady($db->f("content"));
				echo "</SPAN><BR><BR>\n";
			}
		}

		$db->queryf("SELECT * FROM newsletter WHERE visible=1 ORDER BY titel, mkdate");
		if ($open == "")
		if ($db->num_rows() > 0) {
			while ($db->next_record()) {
				if (NWorker::is_member($db->f("newsletter_id")))
					$link = "$PHP_SELF?nlmodus=unjoin&newsletter_id=".$db->f("newsletter_id")."&opennl=".$db->f("newsletter_id")."#ankernl";
				else
					$link = "$PHP_SELF?nlmodus=join&newsletter_id=".$db->f("newsletter_id")."&opennl=".$db->f("newsletter_id")."#ankernl";
				echo "<DIV>\n";
				if ($opennl==$db->f("newsletter_id")) {
					echo "<A NAME=\"ankernl\"></A>\n";
					echo "  <DIV STYLE=\"border-bottom:1px solid gray;\">\n";
					echo "    <IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/rotdown.gif\"><A HREF=\"".$PHP_SELF."#ankernl\"><SPAN STYLE=\"font-size:13px; font-weight:bold;\">".htmlReady($db->f("titel"))."</SPAN></A>\n";
					echo "  </DIV>\n";
					echo "  <DIV>\n";
					echo "    <DIV STYLE=\"text-align:right; font-size:12px; height:6px;\">\n";
					echo "      <A HREF=\"$link\">".(NWorker::is_member($db->f("newsletter_id")) ? "abmelden <IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/x_transparent.gif\" BORDER=\"0\">" : "anmelden <IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/vote_answer_correct.gif\" BORDER=\"0\">")."</A>\n";
					echo "    </DIV>\n";
					echo "<BLOCKQUOTE STYLE=\"font-size:12px;\">\n";
					if (strlen(trim($db->f("description"))) > 0) {
						echo formatReady($db->f("description"))."\n";
					}
					if (NWorker::has_posted_articles($db->f("newsletter_id"))) {
						echo "<BR>\n";
						echo "<A HREF=\"$PHP_SELF?nlmodus=show_archive&open=".$db->f("newsletter_id")."#ankerar\"><IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/cont_folder_sms.gif\" BORDER=\"0\">&nbsp;"._("Newsletter-Archiv")."</A>";
					}
					if ($nlmodus=="join")
						echo "<BR><SPAN STYLE=\"color:green;\">Die Anmeldung war erfolgreich!</SPAN>\n";
					else if ($nlmodus=="unjoin")
						echo "<BR><SPAN STYLE=\"color:green;\">Die Abmeldung war erfolgreich!</SPAN>\n";
					echo "</BLOCKQUOTE>\n";
					echo "</DIV><BR>\n";
				} else {
					echo "    <DIV STYLE=\"border-bottom:1px gray dashed;\" onMouseOver=\"this.style.backgroundColor='#FFFF80';\" onMouseOut=\"this.style.backgroundColor='';\">\n";
					echo "    <DIV STYLE=\"float:left; display:inline;\"><IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/pfeilrot.gif\"><A HREF=\"".$PHP_SELF."?opennl=".$db->f("newsletter_id")."#ankernl\"><SPAN STYLE=\"font-size:13px; font-weight:bold;\">".htmlReady($db->f("titel"))."</SPAN></A></DIV>\n";
					echo "    <DIV STYLE=\"float:right; display:inline; text-align:right; font-size:12px; height:6px;\">\n";
					echo "      <A HREF=\"$link\">".(NWorker::is_member($db->f("newsletter_id")) ? "abmelden <IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/x_transparent.gif\" BORDER=\"0\">" : "anmelden <IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/vote_answer_correct.gif\" BORDER=\"0\">")."</A>\n";
					echo "    </DIV>\n";
					echo "    <DIV STYLE=\"clear:both;\"></DIV>";
					echo "    </DIV>\n";
	
				}
				echo "</DIV>\n";
			}
			echo "<BR>\n";
		} else {
			echo _("Zur Zeit sind keine Newsletter vorhanden.");
		}
	}

	function post_message_on_delete($newsletter_id) {
		$m = new messaging;
		$db = new DB_Seminar();
		$db->queryf("SELECT a.username, n.titel FROM auth_user_md5 a, newsletter_user u, newsletter n WHERE u.newsletter_id='%s' AND n.newsletter_id=u.newsletter_id AND a.user_id=u.user_id",$newsletter_id);
		$message = _("Dieser Newsletter wurde geloescht, Sie wurden automatisch ausgetragen.");
		while ($db->next_record()) {
			$m->insert_message($message, $db->f('username'), "____%system%____", FALSE, FALSE, 1, FALSE, "[" . $db->f("titel")."] Newsletter geloescht!");
		}
	}

	function send_html_mail($email, $subject, $body) {
		// fr HTML-E-Mails muss der 'Content-type'-Header gesetzt werden
		$header  = "MIME-Version: 1.0" . "\r\n";
		$header .= "Content-type: text/html; charset=iso-8859-1" . "\r\n";
		$header .= "From: " . $this->sender_email ."\r\n";
		$header .= "Reply-To:" . $GLOBALS['UNI_CONTACT'] ."\r\n";

		@mail($email, $subject, $body, $header);
	}

	function send_text_mail($email, $subject, $body) {
		$header .= "From: " . $this->sender_email ."\r\n";
		$header .= "Reply-To:" . $GLOBALS['UNI_CONTACT'] ."\r\n";

		@mail($email, $subject, $body, $header);
	}

	function post_it($newsletter_id, $content_id) {
		$db = new DB_Seminar();
		$db->queryf("UPDATE newsletter_content SET posted=UNIX_TIMESTAMP() WHERE content_id='%s'",$content_id); 
		$query = sprintf("SELECT a.Email, n.titel n_titel, c.titel, c.content, c.format, u.sec_token, u.user_id, u.newsletter_id FROM auth_user_md5 a, newsletter n, newsletter_content c, newsletter_user u WHERE c.content_id='%s' AND n.newsletter_id=c.newsletter_id AND u.newsletter_id=n.newsletter_id AND a.user_id=u.user_id",$content_id);
		$query .= sprintf(" UNION SELECT ad.email Email, n.titel n_titel, c.titel, c.content, c.format, ad.sec_token, ad.email_id user_id, ad.newsletter_id FROM newsletter_emails ad, newsletter n, newsletter_content c WHERE c.content_id='%s' AND n.newsletter_id=c.newsletter_id AND ad.newsletter_id=n.newsletter_id ORDER BY 1",$content_id);
		$db->query($query);
		while ($db->next_record()) {
			$unsubscripe_link = $GLOBALS['ABSOLUTE_URI_STUDIP'].$this->getPluginpath()."/unsubscribe.php?nid=".$db->f("newsletter_id")."&uid=".$db->f("user_id")."&tid=".rawurlencode(base64_encode($db->f("sec_token")));
			$unsubscripe_text = "Wenn Sie zuknftig keine Mitteilungen ber diesen Newsletter erhalten wollen, klicken Sie bitte auf diesen Link: ";
			$unsubscribe_html = "<BR><BR>".$unsubscripe_text . "<A HREF=\"$unsubscripe_link\">Austragen</A>";
			$unsubscribe_plaintxt = "\n\n".$unsubscripe_text.$unsubscripe_link;
			if ($db->f("format") == "html") {
				$this->send_html_mail($db->f("Email"), "[" . $db->f("n_titel")."] ".$db->f("titel"), "<HTML><BODY>\n".$db->f("content")."\n".$unsubscribe_html."</BODY></HTML>");
			} else if ($db->f("format") == "studip"){
				$this->send_html_mail($db->f("Email"), "[" . $db->f("n_titel")."] ".$db->f("titel"), "<HTML><BODY>\n".formatReady($db->f("content"),TRUE,TRUE)."\n".$unsubscribe_html."</BODY></HTML>");
			} else
				$this->send_text_mail($db->f("Email"), "[" . $db->f("n_titel")."] ".$db->f("titel"), $db->f("content")."\n".$unsubscribe_plaintxt);
		}
	}

	function post_it_for_testing($newsletter_id, $content_id) {
		$email = trim($_REQUEST['test_email']);
		$db = new DB_Seminar();
		$db->queryf("SELECT n.titel n_titel, c.titel, c.format, c.content FROM newsletter_content c, newsletter n WHERE c.content_id='%s' AND n.newsletter_id=c.newsletter_id",$content_id);
		if ($db->next_record() && $email != "") {
			if ($db->f("format") == "html") {
				$this->send_html_mail($email, "[" . $db->f("n_titel")."] ".$db->f("titel")." [TEST]", "<HTML><BODY>\n".$db->f("content")."\n</BODY></HTML>");
			} else if ($db->f("format") == "studip"){
				$this->send_html_mail($email, "[" . $db->f("n_titel")."] ".$db->f("titel")." [TEST]", "<HTML><BODY>\n".formatReady($db->f("content"),TRUE,TRUE)."\n</BODY></HTML>");
			} else
				$this->send_text_mail($email, "[" . $db->f("n_titel")."] ".$db->f("titel")." [TEST]", $db->f("content"));
		}
	}

	function actionShowAdministrationPage(){
		$GLOBALS['perm']->check('autor');
		$db = new DB_Seminar();
		$db2 = new DB_Seminar();
		$msg = "";
		if($this->permissions->hasAdminPermission()) {
			echo "<TABLE BORDER=\"0\"><TR><TD VALIGN=\"TOP\">\n";
			$a_open = trim($_REQUEST['a_open']);
			$open = trim($_REQUEST['open']);
			$modus = trim($_REQUEST['nlmodus']);
			if ($modus == "create_newsletter") {
				$id =  md5(uniqid(time()));
				$titel = _("Neuer Newsletter");
				$db->queryf("INSERT INTO newsletter (newsletter_id, user_id, titel, mkdate) VALUES ('%s', '%s', '%s', UNIX_TIMESTAMP())",$id, $this->user->getUserId(), $titel);
				$msg = "msg"._("Newsletter angelegt!");
				$open = $id;
			}
			if ($modus == "create_article") {
				$id =  md5(uniqid(time()));
				$newsletter_id = trim($_REQUEST['newsletter_id']);
				if ($newsletter_id != "") {
					$content =_( "Neuer Inhalt");
					$titel = _("Neuer Beitrag");
					$db->queryf("INSERT INTO newsletter_content (content_id, newsletter_id, user_id, titel, content, mkdate) VALUES ('%s', '%s', '%s', '%s', '%s', UNIX_TIMESTAMP())",$id, $newsletter_id, $this->user->getUserId(), $titel, $content);
					$msg = "msg"._("Beitrag angelegt!");
				}
				$a_open = $id;
			}
			if ($modus == "save_newsletter") {
				$id = trim($_REQUEST['newsletter_id']);
				$titel = trim($_REQUEST['titel']);
				$description = trim($_REQUEST['description']);
				$visible = (trim($_REQUEST['visible']) ? 1 : 0);
				if (strlen(trim($titel)) > 0) {
					$db->queryf("UPDATE newsletter SET titel='%s', description='%s', visible=%d WHERE newsletter_id='%s'",$titel,$description,$visible,$id);
					$msg = "msg"._("Newsletter gespeichert!");
				}
				$open = $id;
			}
			if ($modus == "save_article") {
				$id = trim($_REQUEST['content_id']);
				$titel = trim($_REQUEST['titel']);
				$content = trim($_REQUEST['content']);
				$format = $_REQUEST['format'];
				if (strlen(trim($titel)) > 0 && strlen($content) > 0) {
					$db->queryf("UPDATE newsletter_content SET titel='%s', content='%s', format='%s' WHERE content_id='%s'",$titel,$content,$format,$id);
					$msg = "msg"._("Beitrag gespeichert!");
				}
				$a_open = $id;
				$open = trim($_REQUEST['newsletter_id']);
			}
			if ($modus == "post_article" && NWorker::get_count_members($_REQUEST['newsletter_id']) > 0) {
				$id = trim($_REQUEST['content_id']);
				$titel = trim($_REQUEST['titel']);
				$content = trim($_REQUEST['content']);
				$format = $_REQUEST['format'];
				if (strlen(trim($titel)) > 0 && strlen($content) > 0) {
					$db->queryf("UPDATE newsletter_content SET titel='%s', content='%s', format='%s' WHERE content_id='%s'",$titel,$content,$format,$id);
				}
				$a_open = $id;
				$open = trim($_REQUEST['newsletter_id']);
				echo "<A NAME=\"anker\"></A>\n";
				echo "<DIV STYLE=\"width:700px; margin:25px; padding:5px; border-color:red; border-width:thin; border-style:solid\">\n";
				echo "<IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/ausruf.gif\">&nbsp;";
				echo sprintf(_("Wollen Sie den Newsletter-Artikel mit dem Titel <B>%s</B> jetzt an %d Teilnehmer senden?"),$titel,NWorker::get_count_members($open));
				echo "<BR><A HREF=\"".PluginEngine::getLink($this,array("nlmodus"=>"post_article_really","content_id"=>$id,"newsletter_id"=>$open),"showAdministrationPage")."\">".makeButton("ja","img")."</A>&nbsp;\n";
				echo "<A HREF=\"".PluginEngine::getLink($this,array("a_open"=>$id,"open"=>$open),"showAdministrationPage")."\">".makeButton("nein","img")."</A>\n";
				echo "</DIV>\n";
			}
			if ($modus == "post_article_really" && NWorker::get_count_members($_REQUEST['newsletter_id']) > 0) {
				$open = trim($_REQUEST['newsletter_id']);
				$a_open = trim($_REQUEST['content_id']);
				$this->post_it($open, $a_open);
				$msg = "msg"._("Artikel gesendet!");
			}
			if ($modus == "test_posting") {
				$open = $_REQUEST['newsletter_id'];
				$a_open = $_REQUEST['content_id'];
				$titel = trim($_REQUEST['titel']);
				$content = trim($_REQUEST['content']);
				$format = $_REQUEST['format'];
				if (strlen(trim($titel)) > 0 && strlen($content) > 0) {
					$db->queryf("UPDATE newsletter_content SET titel='%s', content='%s', format='%s' WHERE content_id='%s'",$titel,$content,$format,$a_open);
				}
				$this->post_it_for_testing($open, $a_open);
				$msg = "msg"._("You've got mail!");
			}
			if ($modus == "delete_article") {
				$open = trim($_REQUEST['newsletter_id']);
				$a_open = trim($_REQUEST['content_id']);
				echo "<A NAME=\"anker\"></A>\n";
				echo "<DIV STYLE=\"width:700px; margin:25px; padding:5px; border-color:red; border-width:thin; border-style:solid\">\n";
				echo "<IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/ausruf.gif\">&nbsp;";
				echo _("Wollen Sie den Artikel wirklich l&ouml;schen?");
				echo "<BR><A HREF=\"".PluginEngine::getLink($this,array("nlmodus"=>"delete_article_really","newsletter_id"=>$open,"content_id"=>$a_open),"showAdministrationPage")."\">".makeButton("ja","img")."</A>&nbsp;\n";
				echo "<A HREF=\"".PluginEngine::getLink($this,array("open"=>$open,"content_id"=>$a_open),"showAdministrationPage")."\">".makeButton("nein","img")."</A>\n";
				echo "</DIV>\n";	
			}
			if ($modus == "delete_article_really") {
				$open = trim($_REQUEST['newsletter_id']);
				$a_open = trim($_REQUEST['content_id']);
				$db->queryf("DELETE FROM newsletter_content WHERE content_id='%s' AND newsletter_id='%s'",$a_open,$open);
				$msg = "msg."._("Artikel wurde gel&ouml;scht!");
			}
			if ($modus == "delete_newsletter") {
				$id = trim($_REQUEST['newsletter_id']);
				echo "<A NAME=\"anker\"></A>\n";
				echo "<DIV STYLE=\"width:700px; margin:25px; padding:5px; border-color:red; border-width:thin; border-style:solid\">\n";
				echo "<IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/ausruf.gif\">&nbsp;";
				echo sprintf(_("Wollen Sie den Newsletter mit %d Abonnenten wirklich l&ouml;schen?"),NWorker::get_count_members($id));
				echo "<BR><A HREF=\"".PluginEngine::getLink($this,array("nlmodus"=>"delete_newsletter_really","newsletter_id"=>$id),"showAdministrationPage")."\">".makeButton("ja","img")."</A>&nbsp;\n";
				echo "<A HREF=\"".PluginEngine::getLink($this,array("open"=>$id),"showAdministrationPage")."\">".makeButton("nein","img")."</A>\n";
				echo "</DIV>\n";	
			}
			if ($modus == "delete_newsletter_really") {
				$id = trim($_REQUEST['newsletter_id']);
				$this->post_message_on_delete($id);
				$db->queryf("DELETE FROM newsletter_user WHERE newsletter_id='%s'",$id);
				$db->queryf("DELETE FROM newsletter_content WHERE newsletter_id='%s'",$id);
				$db->queryf("DELETE FROM newsletter WHERE newsletter_id='%s'",$id);
				$msg = "msg"._("Newsletter wurde gel&ouml;scht!");
			}

			if ($msg) {
				echo "<TABLE BORDER=\"0\">\n";
				parse_msg($msg);
				echo "</TABLE>\n";
			}

			echo "<BLOCKQUOTE STYLE=\"font-size:12px;\">"._("Neuen Newsletter erstellen")."\n";
			echo "<FORM NAME=\"new_item\" ACTION=\"".PluginEngine::getLink($this,array(),"showAdministrationPage")."\" METHOD=\"POST\">\n";
			echo "<INPUT TYPE=\"hidden\" NAME=\"nlmodus\" VALUE=\"create_newsletter\">\n";
			echo "<INPUT TYPE=\"image\" ".makeButton("anlegen","src").">\n";
			echo "</FORM></BLOCKQUOTE>\n";

			$template = $this->factory->open('js_email');
	                $template->set_attribute('ajax_uri', PluginEngine::getLink($this,array(),'ajaxDispatch'));
	                echo $template->render();


			$db->queryf("SELECT * FROM newsletter ORDER BY titel, mkdate DESC");
			while ($db->next_record()) {
				$member_count = NWorker::get_count_members($db->f("newsletter_id"));
				$link = PluginEngine::getLink($this,array('1'=>1),"showAdministrationPage");
                        	$icon = "<IMG SRC=\"".$GLOBALS['ASSETS_URL']."images/news2.gif\" ALT=\"Newsletter\">";
                        	$tmp_titel=htmlReady(mila($db->f("titel")));
                      		$zusatz = date("d.m.Y H:i",$db->f("mkdate"))." / <B STYLE=\"color:".($member_count > 0 ? "green" : "red")."\">".$member_count." "._("Abonnenten")."</B>&nbsp;/&nbsp;<A HREF=\"about.php?username=".get_username($db->f("user_id"))."\">".htmlReady(get_fullname($db->f("user_id")))."</A>";
                        	$titel = "<A HREF=\"".$link."&open=".($open==$db->f("newsletter_id")?"":$db->f("newsletter_id")."#anker")."\"><FONT SIZE=\"-1\">".$tmp_titel."</FONT></A>";
				echo "             <TABLE BORDER=\"0\" WIDTH=\"100%\" CELLPADDING=\"0\" CELLSPACING=\"0\">\n";
	                        echo "               <TR>\n";
                        	printhead ("100%", 0, $link, ($open==$db->f("newsletter_id")?"open":"close"), FALSE, $icon, $titel, $zusatz, time());
                        	echo "               </TR>\n";
                        	echo "             </TABLE>\n";
				if ($open == $db->f("newsletter_id")) {
					echo "<FORM NAME=\"f".$db->f("newsletter_id")."\" ACTION=\"".PluginEngine::getLink($this,array(),"showAdministrationPage")."\" METHOD=\"POST\">\n";
					echo "<DIV CLASS=\"steel1\" STYLE=\"width:700px; margin:25px; padding:5px; border-color:gray; border-width:thin; border-style:solid\">\n";
					echo "<INPUT TYPE=\"hidden\" NAME=\"nlmodus\" VALUE=\"save_newsletter\">\n";
					echo "<INPUT TYPE=\"hidden\" NAME=\"newsletter_id\" VALUE=\"".$db->f("newsletter_id")."\">\n";
					echo "<B STYLE=\"font-size:12px;\">"._("Titel").":</B><BR>\n";
					echo "<INPUT TYPE=\"text\" NAME=\"titel\" STYLE=\"width:600px\" VALUE=\"".htmlReady($db->f("titel"))."\">\n";
					echo "<INPUT TYPE=\"checkbox\" NAME=\"visible\" VALUE=\"1\" ".($db->f("visible")=="1" ? "CHECKED" : "")."><FONT STYLE=\"font-size:12px;\">"._("sichtbar")."</FONT>\n";
					echo "<B STYLE=\"font-size:12px;\">"._("Kurzbeschreibung").":</B><BR>\n";
					echo "<B STYLE=\"font-size:10px; color:gray\">"._("Hier kann die Stud.IP-Formatierung benutzt werden!")."</B><BR>\n";
					echo "<TEXTAREA NAME=\"description\" STYLE=\"width:600px; height:100px\">".htmlReady($db->f("description"))."</TEXTAREA><BR>\n";
					echo "<INPUT TYPE=\"image\" ".makeButton("speichern","src").">\n";
					echo "<INPUT TYPE=\"image\" onClick=\"document.f".$db->f("newsletter_id").".modus.value='delete_newsletter';\" ".makeButton("loeschen","src").">\n";
					echo "</DIV>\n";
					echo "</FORM>\n";

					$template = $this->factory->open('email_list');
			                $template->set_attribute('ajax_uri', PluginEngine::getLink($this,array(),'ajaxDispatch'));
			                $template->set_attribute('nid', $db->f("newsletter_id"));
					$template->set_attribute('emails', AdditionalEmails::getEmails($db->f("newsletter_id")));
			                echo $template->render();

					echo "<BLOCKQUOTE STYLE=\"font-size:12px\">"._("Neuen Beitrag schreiben")."\n";
					echo "<FORM NAME=\"new_article\" ACTION=\"".PluginEngine::getLink($this,array("open"=>$db->f("newsletter_id")),"showAdministrationPage")."\" METHOD=\"POST\">\n";
					echo "<INPUT TYPE=\"hidden\" NAME=\"newsletter_id\" VALUE=\"".$db->f("newsletter_id")."\">\n";
					echo "<INPUT TYPE=\"hidden\" NAME=\"nlmodus\" VALUE=\"create_article\">\n";
					echo "<INPUT TYPE=\"image\" ".makeButton("anlegen","src").">\n";
					echo "</FORM></BLOCKQUOTE>\n";

					$db2->queryf("SELECT * FROM newsletter_content WHERE newsletter_id='%s' ORDER BY mkdate DESC",$db->f("newsletter_id"));
					if($db2->num_rows() > 0) echo "<BLOCKQUOTE><B STYLE=\"font-size:12px\">"._("Beitr&auml;ge:")."</B>\n";
					
					while ($db2->next_record()) {
						$a_link = PluginEngine::getLink($this,array("open"=>$db->f("newsletter_id")),"showAdministrationPage");
                        			$a_icon = "<IMG SRC=\"".$GLOBALS['ASSETS_URL']."images/news-icon.gif\" ALT=\"Newsletter\">";
                        			$a_tmp_titel=htmlReady(mila($db2->f("titel")));
                      				$a_zusatz = (NWorker::article_already_posted($db2->f(content_id)) ? "<B STYLE=\"color:red\">".date("d.m.Y H:i",$db2->f("posted"))." "._("gesendet")."</B> / " : "") . date("d.m.Y H:i",$db2->f("mkdate"))."&nbsp;/&nbsp;<A HREF=\"about.php?username=".get_username($db2->f("user_id"))."\">".htmlReady(get_fullname($db2->f("user_id")))."</A>";
                        			$a_titel = "<A HREF=\"".$a_link."&a_open=".($a_open==$db2->f("content_id")?"":$db2->f("content_id")."#anker")."\"><FONT SIZE=\"-1\">".$a_tmp_titel."</FONT></A>";
						echo "             <TABLE BORDER=\"0\" WIDTH=\"100%\" CELLPADDING=\"0\" CELLSPACING=\"0\">\n";
	                        		echo "               <TR>\n";
                        			printhead ("100%", 0, $a_link, ($a_open==$db2->f("content_id")?"open":"close"), FALSE, $a_icon, $a_titel, $a_zusatz, time());
                        			echo "               </TR>\n";
                        			echo "             </TABLE>\n";
						if ($a_open == $db2->f("content_id")) {
							if ($db2->f("format") == "html")
								$this->generate_xinha_env();
							echo "<A NAME=\"anker\"></A>\n";
							echo "<FORM NAME=\"f".$db2->f("content_id")."\" ACTION=\"".PluginEngine::getLink($this,array(),"showAdministrationPage")."#anker\" METHOD=\"POST\">\n";
							echo "<DIV CLASS=\"steel1\" STYLE=\"width:730px; margin:25px; padding:5px; border-color:gray; border-width:thin; border-style:solid\">\n";
							echo "<INPUT TYPE=\"hidden\" NAME=\"nlmodus\" VALUE=\"save_article\">\n";
							echo "<INPUT TYPE=\"hidden\" NAME=\"newsletter_id\" VALUE=\"".$db->f("newsletter_id")."\">\n";
							echo "<INPUT TYPE=\"hidden\" NAME=\"content_id\" VALUE=\"".$db2->f("content_id")."\">\n";
							echo "<B STYLE=\"font-size:12px\">"._("Titel").":</B><BR>\n";
							echo "<INPUT TYPE=\"text\" NAME=\"titel\" STYLE=\"width:600px\" VALUE=\"".htmlReady($db2->f("titel"))."\">\n";
							echo "<SELECT NAME=\"format\" STLYE=\"size:1; font-size:12px\" onChange=\"document.f".$db2->f("content_id").".submit();\">\n";
							$f = array("plain"=>"Plain Text", "studip"=>"Stud.IP","html"=>"HTML");
							foreach ($f as $k=>$i)
								echo "  <OPTION VALUE=\"$k\" ".($db2->f("format") == $k ? "SELECTED" : "").">$i\n\n";
							echo "</SELECT>\n";
							echo "<BR><B STYLE=\"font-size:12px\">"._("Inhalt").":</B><BR>\n";
							if ($db2->f("format") == "html" || $db2->f("format") == "plain")
								echo "<B STYLE=\"font-size:10px; color:red\">"._("Hier kann KEINE Stud.IP-Formatierung benutzt werden!")."</B><BR>\n";
							else
								echo "<B STYLE=\"font-size:10px; color:gray\">"._("Hier kann die Stud.IP-Formatierung benutzt werden!")."</B><BR>\n";
							echo "<TEXTAREA ".($db2->f("format")== "html" ? "id=\"content\"" : "")." NAME=\"content\" wrap=virtal STYLE=\"width:600px; height:100px\">".($db2->f("format") == "html" ? $db2->f("content") : htmlReady($db2->f("content")))."</TEXTAREA><BR>\n";
							echo "<INPUT TYPE=\"image\" ".makeButton("speichern","src").">\n";
							echo "<INPUT TYPE=\"image\" onClick=\"document.f".$db2->f("content_id").".nlmodus.value='delete_article';\" ".makeButton("loeschen","src").">\n";
							if (NWorker::get_count_members($db->f("newsletter_id")) > 0) {
								echo "&nbsp;&nbsp;<INPUT TYPE=\"image\" onClick=\"document.f".$db2->f("content_id").".nlmodus.value='post_article';\" ".makeButton("absenden","src").">\n";
							} else {
								echo "<B STYLE=\"font-size:10px; color:red\">"._("Keine Abonnenten!")."</B>\n";
							}
							echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
							echo "<INPUT TYPE=\"image\" onClick=\"if(document.f".$db2->f("content_id").".test_email.value==''){alert('"._("Bitte geben Sie eine gueltige Mailadresse an!")."');return false;}document.f".$db2->f("content_id").".modus.value='test_posting';\" SRC=\"".$GLOBALS['ASSETS_URL']."/images/start_log.gif\" ALT=\""._("Test-Mail verschicken")."\" TITLE=\""._("Test-Mail verschicken")."\">\n";
							echo "<INPUT TYPE=\"text\" NAME=\"test_email\" VALUE=\"".($_REQUEST['test_email'] ? htmlReady(trim($_REQUEST['test_email'])) : NWorker::get_email($GLOBALS['auth']->auth['uid']))."\">\n";
							echo "<B STYLE=\"font-size:10px; color:gray\">("._("Test-Mailadresse").")</B>\n";
							echo "</DIV>\n";
							echo "</FORM>\n";

						}
					}
					if($db2->num_rows() > 0)echo "</BLOCKQUOTE>";
				}
			} 
			echo "</TD><TD>\n";
			echo "<TD WIDTH=\"2%\" VALIGN=\"TOP\">\n";
			echo $this->createInfoBox("sms3.jpg");
			echo "</TD></TR></TABLE>\n";
		} else
			echo _("Zugriff verweigert");
	} 

	function actionAjaxDispatch(){
                if (!$GLOBALS['perm']->have_perm("root")) die;
                ob_end_clean();
                if (!array_key_exists('ajax_cmd', $_REQUEST)) die;
                switch($_REQUEST['ajax_cmd']) {
			case 'insert_email':
                                $nid = trim(escapeshellcmd(basename($_REQUEST['nid'])));
                                $email = trim(escapeshellcmd(basename(utf8_decode($_REQUEST['email_value']))));
                                $name = trim(escapeshellcmd(basename(utf8_decode($_REQUEST['name_value']))));
                                if ($email && $nid) {
					AdditionalEmails::insertEmail($nid, $email, $name);
                                }
                                break;
                        case 'get_emails':
                                $nid = trim(escapeshellcmd(basename($_REQUEST['nid'])));
				if ($nid) {
					$emails = AdditionalEmails::getEmails($nid);
					$out = "";
					if (count($emails))
					foreach ($emails as $e) {
						$template = $this->factory->open('email_item');
                                                $template->set_attribute('email', $e['email']);
                                                $template->set_attribute('email_id', $e['email_id']);
                                                $template->set_attribute('nid', $e['newsletter_id']);
                                                $template->set_attribute('name', $e['name']);
                                                $out .= $template->render();
					}
					echo $out;
				}
                                break;
                        case 'remove_email':
                                $nid = trim(escapeshellcmd(basename($_REQUEST['nid'])));
                                $email_id = trim(escapeshellcmd(basename(utf8_decode($_REQUEST['email_value']))));
				if ($email_id && $nid) {
					AdditionalEmails::removeEmail($nid, $email_id);
				}
                                break;
                        default: ;

		}
		die();
	}

        function hasAdministration() { return TRUE; }
        
        function hasUnauthorizedView() { return FALSE; }
        
        function hasAuthorizedView() { return TRUE; }

}

?>
